/**
 * This class was created by BrassGoggledCoders modding team.
 * This class is available as part of the Steamcraft 2 Mod for Minecraft.
 *
 * Steamcraft 2 is open-source and is distributed under the MMPL v1.0 License.
 * (http://www.mod-buildcraft.com/MMPL-1.0.txt)
 *
 * Steamcraft 2 is based on the original Steamcraft Mod created by Proloe.
 * Steamcraft (c) Proloe 2011
 * (http://www.minecraftforum.net/topic/251532-181-steamcraft-source-code-releasedmlv054wip/)
 *
 */
package xyz.brassgoggledcoders.boilerplate.common.modcompat;

import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fml.common.event.FMLInterModComms;

public class TinkersIMCRegistration
{
	public static void addNewToolMaterial(int matID, String name, int dura, int minespeed, int attack, float handlemodifier, int reinforcedLevel,
			String matTextColor, int color)
	{
		NBTTagCompound tag = new NBTTagCompound();
		tag.func_74768_a("Id", matID);
		tag.func_74778_a("Name", name);
		tag.func_74768_a("Durability", dura);
		tag.func_74768_a("MiningSpeed", minespeed);
		tag.func_74768_a("Attack", attack);
		tag.func_74776_a("HandleModifier", handlemodifier);
		tag.func_74768_a("Reinforced", reinforcedLevel);
		tag.func_74778_a("Style", matTextColor);
		tag.func_74768_a("Color", color);
		// TODO
		tag.func_74768_a("Bow_DrawSpeed", 100);
		tag.func_74776_a("Bow_ProjectileSpeed", 1.0f);
		tag.func_74776_a("Projectile_Mass", 2.0f);
		tag.func_74776_a("Projectile_Fragility", 0.9f);

		FMLInterModComms.sendMessage("TConstruct", "addMaterial", tag);
	}

	public static void addNewSmeltable(ItemStack item, Block toRender, FluidStack toProduce, int tempRequired)
	{
		NBTTagCompound tag = new NBTTagCompound();
		NBTTagCompound itemtag = new NBTTagCompound();
		item.func_77955_b(itemtag);
		tag.func_74782_a("Item", itemtag);
		NBTTagCompound block = new NBTTagCompound();
		(new ItemStack(toRender, 1)).func_77955_b(block);
		tag.func_74782_a("Block", block);
		toProduce.writeToNBT(tag);
		tag.func_74768_a("Temperature", tempRequired);
		FMLInterModComms.sendMessage("TConstruct", "addSmelteryMelting", tag);
	}

	public static void addNewPartBuilderMaterial(int matID, ItemStack mainItem, ItemStack shardItem, int value)
	{
		NBTTagCompound tag = new NBTTagCompound();
		tag.func_74768_a("MaterialId", matID);
		NBTTagCompound item = new NBTTagCompound();
		mainItem.func_77955_b(item);
		tag.func_74782_a("Item", item);

		item = new NBTTagCompound();
		shardItem.func_77955_b(item);
		tag.func_74782_a("Shard", item);

		tag.func_74768_a("Value", value);
		FMLInterModComms.sendMessage("TConstruct", "addPartBuilderMaterial", tag);
	}

	public static void addNewCastable(String fluidName, int materialID)
	{
		NBTTagCompound tag = new NBTTagCompound();
		// liquid to use
		tag.func_74778_a("FluidName", fluidName);
		tag.func_74768_a("MaterialId", materialID);
		FMLInterModComms.sendMessage("TConstruct", "addPartCastingMaterial", tag);
	}

	public static void addNewFluxBattery(Item fluxBattery)
	{
		ItemStack battery = new ItemStack(fluxBattery);
		FMLInterModComms.sendMessage("TConstruct", "addFluxBattery", battery);
	}

	public static void addNewSmeltable(Item item, int metadata, Block toRender, FluidStack toProduce, int tempRequired)
	{
		NBTTagCompound tag = new NBTTagCompound();
		NBTTagCompound itemtag = new NBTTagCompound();
		(new ItemStack(item, 1, metadata)).func_77955_b(itemtag);
		tag.func_74782_a("Item", itemtag);
		NBTTagCompound block = new NBTTagCompound();
		(new ItemStack(toRender, 1)).func_77955_b(block);
		tag.func_74782_a("Block", block);
		toProduce.writeToNBT(tag);
		tag.func_74768_a("Temperature", tempRequired);
		FMLInterModComms.sendMessage("TConstruct", "addSmelteryMelting", tag);
	}
}
